diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 7f41111a6..026509a68 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -8,199 +8,216 @@ import net.minecraft.core.world.type.nether.WorldTypeNether;
 import net.minecraft.core.world.type.nether.WorldTypeNetherSkyblock;
 import net.minecraft.core.world.type.overworld.*;
 import net.minecraft.core.world.type.drift.WorldTypeDrift;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class WorldTypes {
     public static final @NotNull WorldType OVERWORLD_EXTENDED = register(
-            "minecraft:overworld.extended",
-            new WorldTypeOverworld(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.extended")
-            )
+        "minecraft:overworld.extended",
+        new WorldTypeOverworld(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.extended")
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_DEFAULT = register(
-            "minecraft:overworld.default",
-            new WorldTypeOverworld(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.default")
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-            )
+        "minecraft:overworld.default",
+        new WorldTypeOverworld(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.default")
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType NETHER_DEFAULT = register(
-            "minecraft:nether.default",
-            new WorldTypeNether(
-                    WorldTypeNether.defaultProperties("worldType.nether.default")
-                        .portalBounds(63, 255)
-            )
+        "minecraft:nether.default",
+        new WorldTypeNether(
+            WorldTypeNether.defaultProperties("worldType.nether.default")
+                .portalBounds(63, 255)
+                .withTags(WorldTypeTags.NETHER, WorldTypeTags.HOT, WorldTypeTags.BREAKS_COMPASS, WorldTypeTags.BREAKS_TIMEPIECES)
+        )
     );
     public static final @NotNull WorldType NETHER_SKYBLOCK = register(
-            "minecraft:nether.skyblock",
-            new WorldTypeNetherSkyblock(
-                    WorldTypeNether.defaultProperties("worldType.nether.skyblock")
-                        .bounds(0, 127, 0)
-            )
+        "minecraft:nether.skyblock",
+        new WorldTypeNetherSkyblock(
+            WorldTypeNether.defaultProperties("worldType.nether.skyblock")
+                .bounds(0, 127, 0)
+                .withTags(WorldTypeTags.NETHER, WorldTypeTags.HOT, WorldTypeTags.BREAKS_COMPASS, WorldTypeTags.BREAKS_TIMEPIECES)
+        )
     );
     public static final @NotNull WorldType DRIFT_DEFAULT = register(
-            "minecraft:drift.default",
-            new WorldTypeDrift(
-                    WorldTypeDrift.defaultProperties("worldType.drift.default")
-            )
+        "minecraft:drift.default",
+        new WorldTypeDrift(
+            WorldTypeDrift.defaultProperties("worldType.drift.default")
+                .withTags(WorldTypeTags.DRIFT, WorldTypeTags.COLD, WorldTypeTags.BREAKS_COMPASS, WorldTypeTags.BREAKS_TIMEPIECES)
+        )
     );
     public static final @NotNull WorldType FLAT = register(
-            "minecraft:flat",
-            new WorldTypeFlat(
-                    WorldType.Properties.of("worldType.flat")
-                            .brightnessRamp(WorldTypeOverworld.createLightRamp())
-                            .fillerBlock(Blocks.STONE)
-                            .allowRespawn()
-                            .bounds(0, 31, 0)
-                            .portalBounds(0, 255)
-                            .seasonConfig(SeasonConfig.builder()
-                                    .withSingleSeason(Seasons.OVERWORLD_SUMMER)
-                                    .build()
-                            )
-            )
+        "minecraft:flat",
+        new WorldTypeFlat(
+            WorldType.Properties.of("worldType.flat")
+                .brightnessRamp(WorldTypeOverworld.createLightRamp())
+                .fillerBlock(Blocks.STONE)
+                .allowRespawn()
+                .bounds(0, 31, 0)
+                .portalBounds(0, 255)
+                .seasonConfig(SeasonConfig.builder()
+                    .withSingleSeason(Seasons.OVERWORLD_SUMMER)
+                    .build()
+                )
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_FLOATING = register(
-            "minecraft:overworld.floating",
-            new WorldTypeOverworldFloating(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
-                            .bounds(0, 255, 0)
-                            .oceanBlock(null)
-            )
+        "minecraft:overworld.floating",
+        new WorldTypeOverworldFloating(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
+                .bounds(0, 255, 0)
+                .oceanBlock(null)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_AMPLIFIED = register(
-            "minecraft:overworld.amplified",
-            new WorldTypeOverworld(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.amplified")
-                            .bounds(0, 255, 64)
-            )
+        "minecraft:overworld.amplified",
+        new WorldTypeOverworld(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.amplified")
+                .bounds(0, 255, 64)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_RETRO = register(
-            "minecraft:overworld.retro",
-            new WorldTypeOverworldRetro(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.retro")
-                            .seasonConfig(null)
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-                            .setRetro()
-            )
+        "minecraft:overworld.retro",
+        new WorldTypeOverworldRetro(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.retro")
+                .seasonConfig(null)
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD, WorldTypeTags.RETRO)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_ISLANDS = register(
-            "minecraft:overworld.islands",
-            new WorldTypeOverworld(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.islands")
-                            .bounds(0, 255, 160)
-            )
+        "minecraft:overworld.islands",
+        new WorldTypeOverworld(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.islands")
+                .bounds(0, 255, 160)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_WINTER = register(
-            "minecraft:overworld.winter",
-            new WorldTypeOverworld(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.winter")
-                            .seasonConfig(SeasonConfig.builder()
-                                    .withSingleSeason(Seasons.OVERWORLD_WINTER_ENDLESS)
-                                    .build()
-                            )
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-            )
+        "minecraft:overworld.winter",
+        new WorldTypeOverworld(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.winter")
+                .seasonConfig(SeasonConfig.builder()
+                    .withSingleSeason(Seasons.OVERWORLD_WINTER_ENDLESS)
+                    .build()
+                )
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD, WorldTypeTags.ENDLESS_SNOW, WorldTypeTags.COLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_HELL = register(
-            "minecraft:overworld.hell",
-            new WorldTypeOverworldHell(
-                    WorldType.Properties.of("worldType.overworld.hell")
-                            .brightnessRamp(WorldTypeOverworld.createLightRamp())
-                            .seasonConfig(SeasonConfig.builder()
-                                    .withSingleSeason(Seasons.OVERWORLD_HELL)
-                                    .build()
-                            )
-                            .oceanBlock(Blocks.FLUID_LAVA_STILL)
-                            .fillerBlock(Blocks.STONE)
-                            .allowRespawn()
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-                            .defaultWeather(Weathers.OVERWORLD_HELL_CLEAR)
-            )
+        "minecraft:overworld.hell",
+        new WorldTypeOverworldHell(
+            WorldType.Properties.of("worldType.overworld.hell")
+                .brightnessRamp(WorldTypeOverworld.createLightRamp())
+                .seasonConfig(SeasonConfig.builder()
+                    .withSingleSeason(Seasons.OVERWORLD_HELL)
+                    .build()
+                )
+                .oceanBlock(Blocks.FLUID_LAVA_STILL)
+                .fillerBlock(Blocks.STONE)
+                .allowRespawn()
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .defaultWeather(Weathers.OVERWORLD_HELL_CLEAR)
+                .withTags(WorldTypeTags.OVERWORLD, WorldTypeTags.HOT)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_WOODS = register(
-            "minecraft:overworld.woods",
-            new WorldTypeOverworldWoods(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.woods")
-                            .defaultWeather(Weathers.OVERWORLD_WOODS_CLEAR)
-            )
+        "minecraft:overworld.woods",
+        new WorldTypeOverworldWoods(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.woods")
+                .defaultWeather(Weathers.OVERWORLD_WOODS_CLEAR)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_PARADISE = register(
-            "minecraft:overworld.paradise",
-            new WorldTypeOverworldParadise(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.paradise")
-                            .seasonConfig(SeasonConfig.builder()
-                                    .withSingleSeason(Seasons.OVERWORLD_SPRING)
-                                    .build()
-                            )
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-            )
+        "minecraft:overworld.paradise",
+        new WorldTypeOverworldParadise(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.paradise")
+                .seasonConfig(SeasonConfig.builder()
+                    .withSingleSeason(Seasons.OVERWORLD_SPRING)
+                    .build()
+                )
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_INLAND = register(
-            "minecraft:overworld.inland",
-            new WorldTypeOverworldInland(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.inland")
-                            .bounds(0, 255, 0)
-                            .oceanBlock(null)
-            )
+        "minecraft:overworld.inland",
+        new WorldTypeOverworldInland(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.inland")
+                .bounds(0, 255, 0)
+                .oceanBlock(null)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_CLASSIC = register(
-            "minecraft:overworld.classic",
-            new WorldTypeOverworldClassic(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.classic")
-                            .seasonConfig(null)
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-                            .setRetro()
-            )
+        "minecraft:overworld.classic",
+        new WorldTypeOverworldClassic(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.classic")
+                .seasonConfig(null)
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD, WorldTypeTags.RETRO)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_INDEV = register(
-            "minecraft:overworld.indev",
-            new WorldTypeOverworldIndev(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.indev")
-                            .seasonConfig(null)
-                            .bounds(0, 127, 64)
-                            .portalBounds(0, 255)
-                            .setRetro()
-            )
+        "minecraft:overworld.indev",
+        new WorldTypeOverworldIndev(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.indev")
+                .seasonConfig(null)
+                .bounds(0, 127, 64)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD, WorldTypeTags.RETRO)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_SKYBLOCK = register(
-            "minecraft:overworld.skyblock",
-            new WorldTypeOverworldSkyblock(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.skyblock")
-                        .bounds(0, 127, 0)
-                        .portalBounds(0, 255)
-            )
+        "minecraft:overworld.skyblock",
+        new WorldTypeOverworldSkyblock(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.skyblock")
+                .bounds(0, 127, 0)
+                .portalBounds(0, 255)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType OVERWORLD_BETA_173 = register(
-            "minecraft:overworld.beta_173",
-            new WorldTypeOverworldB173(
-                    WorldTypeOverworld.defaultProperties("worldType.overworld.beta_173")
-                            .bounds(0, 127, 64)
-            )
+        "minecraft:overworld.beta_173",
+        new WorldTypeOverworldB173(
+            WorldTypeOverworld.defaultProperties("worldType.overworld.beta_173")
+                .bounds(0, 127, 64)
+                .withTags(WorldTypeTags.OVERWORLD)
+        )
     );
     public static final @NotNull WorldType EMPTY = register(
-            "minecraft:empty",
-            new WorldTypeEmpty(
-                    WorldType.Properties.of("worldType.empty")
-                            .brightnessRamp(WorldTypeEmpty.createLightRamp())
-                            .bounds(0, 255, 0)
-                            .allowRespawn()
-            )
+        "minecraft:empty",
+        new WorldTypeEmpty(
+            WorldType.Properties.of("worldType.empty")
+                .brightnessRamp(WorldTypeEmpty.createLightRamp())
+                .bounds(0, 255, 0)
+                .allowRespawn()
+        )
     );
     public static final @NotNull WorldType DEBUG = register(
-            "minecraft:debug",
-            new WorldTypeDebug(
-                    WorldType.Properties.of("worldType.debug")
-                            .brightnessRamp(WorldTypeDebug.createLightRamp())
-                            .bounds(0, 255, 0)
-                            .allowRespawn()
-            )
+        "minecraft:debug",
+        new WorldTypeDebug(
+            WorldType.Properties.of("worldType.debug")
+                .brightnessRamp(WorldTypeDebug.createLightRamp())
+                .bounds(0, 255, 0)
+                .allowRespawn()
+        )
     );
 
     public static @NotNull WorldType register(final @NotNull String key, final @NotNull WorldType worldType) {
@@ -209,5 +226,6 @@ public abstract class WorldTypes {
         return worldType;
     }
 
-    public static void init() { }
+    public static void init() {
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index f1d3328e7..453d831db 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkGeneratorOverworld;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weather;
 import org.jetbrains.annotations.NotNull;
 
@@ -28,17 +29,17 @@ public class WorldTypeOverworld extends WorldType {
 
     public static @NotNull Properties defaultProperties(@NotNull String translationKey) {
         return Properties.of(translationKey)
-                .brightnessRamp(createLightRamp())
-                .seasonConfig(SeasonConfig.builder()
-                        .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
-                        .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
-                        .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
-                        .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
-                        .build()
-                )
-                .oceanBlock(Blocks.FLUID_WATER_STILL)
-                .fillerBlock(Blocks.STONE)
-                .allowRespawn();
+            .brightnessRamp(createLightRamp())
+            .seasonConfig(SeasonConfig.builder()
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
+                .build()
+            )
+            .oceanBlock(Blocks.FLUID_WATER_STILL)
+            .fillerBlock(Blocks.STONE)
+            .allowRespawn();
     }
 
     public static float[] createLightRamp() {
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/tag/WorldTypeTags.java b/game/core/src/main/java/net/minecraft/core/world/type/tag/WorldTypeTags.java
new file mode 100644
index 000000000..330d6df4d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/type/tag/WorldTypeTags.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.world.type.tag;
+
+import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+
+public final class WorldTypeTags {
+    private WorldTypeTags() throws IllegalAccessException {
+        throw new IllegalAccessException("Attempted instantiation of helper class!");
+    }
+
+    /**
+     * World type is of a "retro" variety - e.g. displays old grass, cobblestone textures
+     */
+    public static final @NotNull Tag<WorldType> RETRO = Tag.of("retro");
+
+    /**
+     * World type displays behaviors consistent with the Overworld dimension.
+     */
+    public static final @NotNull Tag<WorldType> OVERWORLD = Tag.of("overworld");
+
+    /**
+     * World type displays behaviors consistent with the Nether dimension.
+     */
+    public static final @NotNull Tag<WorldType> NETHER = Tag.of("nether");
+
+    /**
+     * World type displays behaviors consistent with the Drift dimension.
+     */
+    public static final @NotNull Tag<WorldType> DRIFT = Tag.of("drift");
+
+    /**
+     * World type is hotter than the Overworld.
+     */
+    public static final @NotNull Tag<WorldType> HOT = Tag.of("hot");
+
+    /**
+     * World type is colder than the Overworld.
+     */
+    public static final @NotNull Tag<WorldType> COLD = Tag.of("cold");
+
+    /**
+     * World type is covered in omnipresent snow.
+     */
+    public static final @NotNull Tag<WorldType> ENDLESS_SNOW = Tag.of("endless_snow");
+
+    /**
+     * Compass displays screwy behavior in this world type.
+     */
+    public static final @NotNull Tag<WorldType> BREAKS_COMPASS = Tag.of("breaks_compass");
+
+    /**
+     * Timepieces (clock, rotary calendar) display screwy behavior in this world type.
+     */
+    public static final @NotNull Tag<WorldType> BREAKS_TIMEPIECES = Tag.of("breaks_timepieces");
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index ce6d5835d..f69505d13 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.weather;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.PropertyKey;
@@ -69,7 +70,7 @@ public abstract class Weather {
             final int blockId = world.getBlockId(x, y, z);
             final int blockIdBelow = world.getBlockId(x, y - 1, z);
 
-            if (world.getBlockBiome(x, y, z).hasSurfaceSnow()) {
+            if (world.getBlockBiome(x, y, z).hasTag(BiomeTags.HAS_SURFACE_SNOW)) {
                 if (blockId == Blocks.LAYER_SNOW.id()) {
                     final int meta = world.getBlockMetadata(x, y, z);
                     if (meta != 0) {
@@ -106,7 +107,7 @@ public abstract class Weather {
                 int blockId = chunk.getBlockID(x, y, z);
                 int blockIdBelow = chunk.getBlockID(x, y - 1, z);
 
-                if (world.getBlockBiome(chunk.pos.x * 16 + x, y, chunk.pos.z * 16 + z).hasSurfaceSnow()) {
+                if (world.getBlockBiome(chunk.pos.x * 16 + x, y, chunk.pos.z * 16 + z).hasTag(BiomeTags.HAS_SURFACE_SNOW)) {
                     if (blockId == Blocks.LAYER_SNOW.id()) {
                         chunk.setBlockMetadata(x, y, z, 0);
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index b506f58d3..2d3e063ba 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -8,6 +8,7 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.pos.TilePos;
@@ -45,14 +46,13 @@ public class WeatherSnow
         if (world.getWeatherManager().getWeatherPower() <= 0.6f) return;
         for (int x = 0; x < 16; x++) {
             int worldX = chunk.pos.x * 16 + x;
-            zLoop:
             for (int z = 0; z < 16; z++) {
                 int worldZ = chunk.pos.z * 16 + z;
                 int y = world.findTopSolidBlock(worldX, worldZ);
 
                 Biome biome = world.getBlockBiome(worldX, y, worldZ);
-                for (int i = 0; i < biome.blockedWeathers.length; i++) {
-                    if (biome.blockedWeathers[i] == this) continue zLoop;
+                if (biome.blockedWeathers.contains(this)) {
+                    continue;
                 }
 
                 int blockId = chunk.getBlockID(x, y, z);
@@ -92,8 +92,8 @@ public class WeatherSnow
         int blockIdBelow = world.getBlockId(x, y - 1, z);
 
         Biome biome = world.getBlockBiome(x, y, z);
-        for (int i = 0; i < biome.blockedWeathers.length; i++) {
-            if (biome.blockedWeathers[i] == this) return;
+        if (biome.blockedWeathers.contains(this)) {
+            return;
         }
 
         if (world.getWeatherManager().getWeatherPower() > 0.6f && y >= 0 && y < world.getHeightBlocks() && world.getSavedLightValue(LightLayer.Block, x, y, z) < 10) {
@@ -101,7 +101,12 @@ public class WeatherSnow
                 if (snow) {
                     world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id());
                 }
-            } else if (world.getWeatherManager().getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id() && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER)) {
+            } else if (
+                world.getWeatherManager().getWeatherPower() > 0.5f &&
+                blockId == Blocks.LAYER_SNOW.id() &&
+                world.getSeasonManager().getCurrentSeason() != null &&
+                (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome.hasTag(BiomeTags.DEEPER_SNOW))
+            ) {
                 if (snow) {
                     Blocks.LAYER_SNOW.getLogic().accumulate(world, new TilePos(x, y, z));
                 }
diff --git a/game/core/src/main/resources/lang/en_US/biomes.lang b/game/core/src/main/resources/lang/en_US/biomes.lang
index c63d7b317..3d5aeee0a 100644
--- a/game/core/src/main/resources/lang/en_US/biomes.lang
+++ b/game/core/src/main/resources/lang/en_US/biomes.lang
@@ -2,7 +2,6 @@ biome.overworld.rainforest=Rainforest
 biome.overworld.swampland=Swamp
 biome.overworld.seasonal_forest=Seasonal Forest
 biome.overworld.forest=Forest
-biome.overworld.forest.dry=Dry Forest
 biome.overworld.grasslands=Grasslands
 biome.overworld.outback=Outback
 biome.overworld.shrubland=Shrubland
@@ -26,7 +25,7 @@ biome.nether.old_world=The Old World
 biome.nether.volcanic_islands=Volcanic Islands
 biome.nether.sulfur_pools=Sulfur Pools
 biome.nether.crystal_forest=Crystal Forest
-biome.nether.crystal_field=Crystal Field
+biome.nether.crystal_plains=Crystal Plains
 biome.nether.shelf=The Shelf
 biome.drift.drift=Drift
 
diff --git a/game/core/src/main/resources/lang/en_US/strings.lang b/game/core/src/main/resources/lang/en_US/strings.lang
index a7991f724..a9e8760e3 100644
--- a/game/core/src/main/resources/lang/en_US/strings.lang
+++ b/game/core/src/main/resources/lang/en_US/strings.lang
@@ -16,6 +16,7 @@ weather.overworld.clear.name=Clear
 weather.overworld.hell.clear.name=Clear
 weather.overworld.woods.clear.name=Clear
 weather.overworld.rain.name=Raining
+weather.overworld.rain.blood.name=Raining?
 weather.overworld.snow.name=Snowing
 weather.overworld.winter.snow.name=Snowing
 weather.overworld.storm.name=Thundering
